
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Select_corner_GUI
%   by Petra Kocmanova
%   last modified: 22.6.2015
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function varargout = Select_corners_GUI(varargin)
% SELECT_CORNERS_GUI MATLAB code for Select_corners_GUI.fig
%      SELECT_CORNERS_GUI, by itself, creates a new SELECT_CORNERS_GUI or raises the existing
%      singleton*.
%
%      H = SELECT_CORNERS_GUI returns the handle to a new SELECT_CORNERS_GUI or the handle to
%      the existing singleton*.
%
%      SELECT_CORNERS_GUI('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in SELECT_CORNERS_GUI.M with the given input arguments.
%
%      SELECT_CORNERS_GUI('Property','Value',...) creates a new SELECT_CORNERS_GUI or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before Select_corners_GUI_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to Select_corners_GUI_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help Select_corners_GUI

% Last Modified by GUIDE v2.5 22-Jun-2015 16:01:47

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @Select_corners_GUI_OpeningFcn, ...
                   'gui_OutputFcn',  @Select_corners_GUI_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT





% --- Executes just before Select_corners_GUI is made visible.
function Select_corners_GUI_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to Select_corners_GUI (see VARARGIN)

% Choose default command line output for Select_corners_GUI
handles.output = hObject;


global images_number
global im_k
global use_im
global skip


if skip == 0
    
    im_k=[1 0 0 0 0]; %number of camera for corner selection
    use_im=false(5,images_number);
    
    set(handles.uitable1, 'Data', cell(5, images_number ));
    use_im(1:5,1:images_number)=false;
    set(handles.uitable1, 'Data', use_im);
    set(handles.uitable1, 'RowName', {'TOF', 'CCD_l', 'CCD_r','THERMO_l','THERMO_r'});
    
    select_corners(handles, im_k)
else
    im_k=[1 0 0 0 0]; %number of camera for corner selection
    use_im=false(5,images_number);
    
    set(handles.uitable1, 'Data', cell(5, images_number ));
    use_im(1:5,1:images_number)=false;
    set(handles.uitable1, 'Data', use_im);
    set(handles.uitable1, 'RowName', {'TOF', 'CCD_l', 'CCD_r','THERMO_l','THERMO_r'});

end

% Updfalseate handles structure
guidata(hObject, handles);

% UIWAIT makes Select_corners_GUI wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = Select_corners_GUI_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes on button press in pushbutton1.
function pushbutton1_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global im_k
global images_number
global cameras

n_camera=get(handles.popupmenu1,'Value');

switch n_camera
    case 1
        k=1;
    case 2
        k=2;
    case 3
        k=3;
    case 4
        k=4;
    case 5
        k=5;
    otherwise
        disp('camera was not choosed')
end

if im_k(1,k)==images_number
    camera_desc=strrep(cameras(k,1).name,'.png',' camera ');
    msgbox(['Corners have been selected for all ' camera_desc 'images!'],'Warning','warn');
else
    im_k(1,k)=im_k(1,k)+1;
    select_corners(handles, im_k);        
end



% --- Executes on button press in pushbutton2.
function pushbutton2_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global im_k
global images_number
global use_im
global cameras
global images

n_camera=get(handles.popupmenu1,'Value');

switch n_camera
    case 1
        k=1;
    case 2
        k=2;
    case 3
        k=3;
    case 4
        k=4;
    case 5
        k=5;
    otherwise
        disp('camera was not choosed')
end

if im_k(1,k)==1
    camera_desc=strrep(cameras(k,1).name,'.png',' camera ');
    msgbox('Select another camera','Warning','warn');
else
im_k(1,k)=im_k(1,k)-1;
select_corners(handles, im_k);
end


% --- Executes on selection change in popupmenu1.
function popupmenu1_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = cellstr(get(hObject,'String')) returns popupmenu1 contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenu1

    



% --- Executes during object creation, after setting all properties.
function popupmenu1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenu1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% --- Executes during object creation, after setting all properties.
function uitable1_CreateFcn(hObject, eventdata, handles)
% hObject    handle to uitable1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called


% --- Executes on button press in pushbutton3.
function pushbutton3_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
global images

close Select_corners_GUI;


