
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   cost_ext
%   by Petra Kocmanova
%   last modified: 27.6.2015
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [ cost_ext ] = cost_ext( init_data_ext,param0)
%Cost function

global cameras
global images
global use_im

param=param0;
[images_number, cameras_number]=size(images);
vect=1;


for k=1:cameras_number
    param.K{k}=[init_data_ext(vect) 0 init_data_ext(vect+2);
        0  init_data_ext(vect+1) init_data_ext(vect+3);
        0 0 1];
    vect=vect+4;
end


param.Rext=cell(1,sum(use_im(1,:)));
param.text=cell(1,sum(use_im(1,:)));
for i=1:images_number
    if use_im(1,i)
        param.Rext{i}=rotationmat(init_data_ext(vect:vect+2));
        vect=vect+3;
        param.text{i}=init_data_ext(vect:vect+2)';
        vect=vect+3;
    end
end

param.R=cell(1,cameras_number);
param.t=cell(1,cameras_number);
param.R{1} = eye(3);
param.t{1} = zeros(3,1);

for k=2:cameras_number
    param.R{k}=rotationmat(init_data_ext(vect:vect+2));
    vect=vect+3;
    param.t{k}=init_data_ext(vect:vect+2)';
    vect=vect+3;
end

cost_ext=[];

for k=1:cameras_number
    im_n=sum(use_im(k,:));
    corner_n=size(images(1,k).grid_x,2); %opravit,kdyby 1 nebyla uren
    total_n=im_n*corner_n;
    cost{k}=zeros(total_n,1);
    vect=1;
    
    K=param.K{k};
    kk=cameras(k,1).k;
    
    for i=1:images_number
        if use_im(k,i)
            X=images(i,k).grid_x;
            R=param.R{k}'*param.Rext{i};
            t=param.R{k}'*(param.text{i} - param.t{k});
            
            pp = project_points(X,K,kk,R,t);
            rep_error=images(i,k).grid_p(1:2,:)-pp;
            cost{k}(vect:vect+numel(rep_error)-1)=rep_error(:);
            vect=vect+numel(rep_error);
        end
    end
    
    cost_m{k}=  cost{k}/sqrt(var(cameras(k,1).rep_error));
    cost_ext=[cost_ext; cost_m{k}]
end


end

