
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   image_preview
%   by Petra Kocmanova
%   last modified: 27.6.2015
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [ area ] = image_preview( AMPL)
%Image preview for for definition of image area for calibration

figure(1)
imagesc(AMPL');
hold on
colormap gray
h=msgbox('Define the area for calibration','Area definition');
uiwait(h);

rect=getrect;%rect = [xmin ymin width height]
plot([rect(1);rect(1)+rect(3);rect(1)+rect(3);rect(1);rect(1)],...
    [rect(2);rect(2);rect(2)+rect(4);rect(2)+rect(4);rect(2)],'-','Color',...
    'red','LineWidth',4)

area=round([rect(1) rect(1)+rect(3);
    rect(2) rect(2)+rect(4)]);

choice = questdlg('Is area for calibration correct?', ...
    'Area definition',...
    'Yes','No','Yes');
% Handle response
switch choice
    case 'Yes'
        close gcf
    case 'No'
        disp([choice 'Define new area for calibration']);
        image_preview(AMPL);
end
end


