
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   order_corners
%   by Petra Kocmanova
%   last modified: 23.6.2015
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function pp = project_points( X,K,k,R,t)
%Compute projected image coordinates from 3D object coordinates

Xc = bsxfun(@plus,R*X,t);

%Point normalization
Xn = bsxfun(@rdivide,Xc(1:2,:),Xc(3,:));

%Distortion
Xd = distort(Xn,k);

%Projection to image plane
pp = [K(1,1)*Xd(1,:) + K(1,3);
     K(2,2)*Xd(2,:) + K(2,3)];

end

