
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   select_images
%   by Petra Kocmanova
%   last modified: 27.6.2015
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [] = select_images()
%Select images for mutual calibration
%   Open images TOF_filter.png, CCD_left.png, CCD_right.png,
%   THERMO_left.png, THERMO_right.png from folders meas_yyyy_mm_dd_hh_mm_ss
%   in user selected folder. Number images from 001 to i. Copy number 
%   images to folder calibration data.


%Output
global path_calibration_data
global cameras
global images_number

path_calibration_data=uigetdir;%('E:\vsechny_spolecne_kalibrace\20150216-snad_pujde_najit_upravene_termo\testovaci');
%path_calibration_data=uigetdir('D:\Peta\doktorske\FEKT\program dizertace\kalibrace 06082013\jen_nektere5');
%path_calibration_data=uigetdir('D:\Peta\doktorske\FEKT\vse_spolecna_kalibrace\overeni_presnosti_16_02_2015\test');
listing=dir(path_calibration_data);

if isequal(exist([path_calibration_data '\calibration_data'], 'dir'),7) 
    rmdir([path_calibration_data '\calibration_data'], 's')
end


images_number=length(listing);
mkdir(path_calibration_data,'calibration_data');


%filtration to only folders with measured data
j=0;
images_list=struct;

for i=1:images_number
    comp=strncmp(listing(i,1).name,'meas',4);
    if comp==1
        j=j+1;
        images_list(j,1).name=listing(i,1).name;
    end
end

images_number=j;

%choose cameras
cameras(1,1).name='TOF_filter.png';
cameras(2,1).name='CCD_left.png';
cameras(3,1).name='CCD_right.png'; 
cameras(4,1).name='THERMO_left.png';
cameras(5,1).name='THERMO_right.png';

cameras_number=length(cameras);


%saving all images to folder calibration data
for i=1:images_number
    if i<10
        for k=1:cameras_number
        copyfile([path_calibration_data '\' images_list(i,1).name '\' cameras(k,1).name],...
            [path_calibration_data '\calibration_data\00' num2str(i) cameras(k,1).name]);
            
        end
    elseif i<100
        for k=1:cameras_number
        copyfile([path_calibration_data '\' images_list(i,1).name '\' cameras(k,1).name],...
            [path_calibration_data '\calibration_data\0' num2str(i) cameras(k,1).name]);
        end
    else
        for k=1:cameras_number
        copyfile([path_calibration_data '\' images_list(i,1).name '\' cameras(k,1).name],...
            [path_calibration_data '\calibration_data\' num2str(i) cameras(k,1).name]);
        end   
    end
end

msgbox('Images have been selected','Image selection');

end

